unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, MemTableDataEh, Data.DB,
  DBGridEhGrouping, ToolCtrlsEh, DBGridEhToolCtrls, DynVarsEh, EhLibVCL,
  GridsEh, DBAxisGridsEh, DBGridEh, Vcl.StdCtrls, MemTableEh;

type
  TForm1 = class(TForm)
    MemTableEh1: TMemTableEh;
    MemTableEh1id: TAutoIncField;
    MemTableEh1ref: TRefObjectField;
    btnAppend: TButton;
    DBGridEh1: TDBGridEh;
    DataSource1: TDataSource;
    btnDelete: TButton;
    btnClose: TButton;
    btnAppend2: TButton;
    btnFree: TButton;
    procedure btnAppendClick(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnAppend2Click(Sender: TObject);
    procedure btnFreeClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TTestObj = class(TInterfacedObject)
  public
    destructor Destroy; override;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.btnAppendClick(Sender: TObject);
begin
  MemTableEh1.Append;
  MemTableEh1ref.Value := TTestObj.Create;
  MemTableEh1.Post;
end;

procedure TForm1.btnDeleteClick(Sender: TObject);
begin
  MemTableEh1.Delete;
end;

procedure TForm1.btnCloseClick(Sender: TObject);
begin
  MemTableEh1.Close;
end;

procedure TForm1.btnAppend2Click(Sender: TObject);
begin
  MemTableEh1.Append;
  MemTableEh1ref.AsVariant := RefObjectToVariant(TTestObj.Create);
  MemTableEh1.Post;
end;

procedure TForm1.btnFreeClick(Sender: TObject);
begin
  MemTableEh1.Free;
end;

{ TTestObj }

destructor TTestObj.Destroy;
begin
  MessageBox(0, 'Bye', 'Bye', 0);
  inherited;
end;

end.
